#ifndef PAINTERENGINE_APPLICATION_H
#define PAINTERENGINE_APPLICATION_H

#ifdef __cplusplus
extern "C"{
#endif

#include "PainterEngine_Startup.h"
	typedef enum 
	{
		PX_APPLICATION_STATE_SHOW,
		PX_APPLICATION_STATE_PROCESSING,
		PX_APPLICATION_STATE_PLAYING,
	}PX_APPLICATION_STATE;

	typedef struct
	{
		PX_Object* root;
		PX_Object* image_logo;
		PX_Object* button_openfile,* button_play,*button_stop;
		PX_Object* sliderbar_progress, *sliderbar_hzrange;
		PX_Object* messagebox;
		PX_APPLICATION_STATE state;
		px_int progress_byte_offset;
		px_float pitch[256*60*20];//20 min
		px_float pixels_per_hz;
		px_float pixels_per_step;

		px_int samples_count;
		px_int view_index;
		px_float center_view_hz;
		px_texture logo;
		px_texture surface_freqdisplay;
		PX_Runtime runtime;
		PX_SoundData sounddata;
	}PX_Application;

	extern PX_Application App;

	px_bool PX_ApplicationInitialize(PX_Application* App, px_int screen_Width, px_int screen_Height);
	px_void PX_ApplicationUpdate(PX_Application* App, px_dword elapsed);
	px_void PX_ApplicationRender(PX_Application* App, px_dword elapsed);
	px_void PX_ApplicationPostEvent(PX_Application* App, PX_Object_Event e);
#ifdef __cplusplus
}
#endif

#endif
